#### write_at (3 of 8 overloads)

Write a certain amount of data at a specified offset before returning.

    template<
        typename SyncRandomAccessWriteDevice,
        typename ConstBufferSequence,
        typename CompletionCondition>
    std::size_t write_at(
        SyncRandomAccessWriteDevice & d,
        uint64_t offset,
        const ConstBufferSequence & buffers,
        CompletionCondition completion_condition,
        constraint_t< is_completion_condition< CompletionCondition >::value >  = 0);

This function is used to write a certain number of bytes of data to a random access device at a specified offset. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.
- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the device's write_some_at function.

###### Parameters

d

  The device to which the data is to be written. The type must support the SyncRandomAccessWriteDevice concept.

offset

  The offset at which the data will be written.

buffers

  One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the device.

completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest write_some_at operation.
        const asio::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the write operation is complete. A non-zero return value indicates the maximum number of bytes to be written on the next call to the device's write_some_at function.

###### Return Value

The number of bytes transferred.

###### Exceptions

asio::system_error

  Thrown on failure.

###### Example

To write a single data buffer use the `buffer` function as follows:

    asio::write_at(d, 42, asio::buffer(data, size),
       asio::transfer_at_least(32));

See the `buffer` documentation for information on writing multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.